/*
            
*/

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <vector>
#include <string>
#include <iostream>
#include <cmath>
#include <cctype>
#include <sstream>
#include <algorithm>
#include <iomanip>
#include <set>
#include <queue>

using namespace std;

int main()
{
    freopen("input.txt" ,"rt", stdin); freopen("output.txt", "wt", stdout);
    
    int best_div_num = 1;
    int best_i = 1;

    for (int i = 2; i <= 1000000000; i++) {
        int x = i;
        int div_num = 1;

        //cout << i << " divisors: ";

        for (int j = 2; j <= 31; j++) {
            int deg = 0;
            while (x % j == 0) {
                deg++;
                x /= j;
            }
            if (deg) {
                div_num *= deg+1;
                //cout << j << "^" << deg << " | ";
            }
            if (x == 1) break;
        }

        //cout << endl;

        if (x == 1 && div_num > best_div_num) {
            best_div_num = div_num;
            best_i = i;            
        }

        if (i % 1000000 == 0) {
            cout << "intermediate report on i = " << i << " | ";
            cout << "best_i: " << best_i << " | ";
            cout << "best_div_num: " << best_div_num << endl;
        }
    }

    cout << "final report" << endl;
    cout << "best_i: " << best_i << endl;
    cout << "best_div_num: " << best_div_num << endl;

    fclose(stdin); fclose(stdout);
    return 0;   
}
